#include "asm86.h"
#include "Ti86abs.inc"
#include "Ti86asm.inc"


.org _asm_exec_ram

 ld hl,$5a92
 rst 20h
 rst 10h
 jr c,Install
 call _delvar
Install:
 ld hl,$5a92
 rst 20h
 ld hl, code_end - code
 call _CREATEPROG
 ld a,b
 ex de,hl
 call $4c3f
 call _SET_ABS_DEST_ADDR
 xor a
 ld hl,code_end - code
 call _SET_MM_NUM_BYTES
 xor a
 ld hl,code
 call _SET_ABS_SRC_ADDR
 call _mm_ldir
 set 6,(iy+$24)
 ret

code:
.db $8e,$28
 call $479f				;pop op1
 ld a,(_asm_reg_a)
 push af
 cp $28				;check for x-var keypress
 jr z,toggle
 jr create_cursor
toggle:				;toggle our cursor
 ld a,(iy+18)
 bit 3,a
 jr nz,end			;don't toggle if other cursors are set
 bit 4,a
 jr nz,end
 bit 5,a
 jr nz,end
 bit 6,a
 jr nz,end
 pop af
 ld a,0
 push af
 bit 7,(iy+$2f)
 jr z,set_cursor
reset_cursor:
 res 7,(iy+$2f)
 jr end
set_cursor:
 set 7,(iy+$2f)
create_cursor:
 bit 7,(iy+$2f)		;check if our cursor flag is set
 jr nz,end
 ld hl,($c00f)
 ld b,l
loop:				;this loop adds 21 to the column for each
 ld a,21			;  row of the current cursor position
 add a,h
 ld h,a
 djnz loop
 ld l,h
 ld h,0
 ld de,$c0f9
 add hl,de		;and add it to text memory
 ld a,(hl)
 cp $df			;check if cursor normal
 jr nz,end
 ld a,$23		
 call _putmap	;if it is, replace it with ours
 call do_stuff
end:
 pop af
 cp a
 ret
do_stuff:
 pop af
	;put your keypress checks, etc here
	;a reg contains getkey
 push af
 ret
code_end:

.end
.end